package rip.tilly.bedwars.providers.tablist;

import club.frozed.tablist.adapter.TabAdapter;
import club.frozed.tablist.entry.TabEntry;
import club.frozed.tablist.skin.Skin;
import com.google.common.collect.Lists;
import com.mojang.authlib.GameProfile;
import com.mojang.authlib.properties.Property;
import org.bukkit.Bukkit;
import org.bukkit.craftbukkit.v1_8_R3.entity.CraftPlayer;
import org.bukkit.entity.Player;
import rip.tilly.bedwars.BedWars;
import rip.tilly.bedwars.utils.CC;

import java.util.List;

public class TablistProvider implements TabAdapter {

    private final BedWars plugin = BedWars.getInstance();

    @Override
    public String getHeader(Player player) {
        return CC.translate("&d&lTilly RIP &7┃ &fBedWars");
    }

    @Override
    public String getFooter(Player player) {
        return CC.translate("&7tilly.rip");
    }

    @Override
    public List<TabEntry> getLines(Player player) {
        List<TabEntry> lines = Lists.newArrayList();
        int column = 0;
        int row = 0;
        for (Player online : Bukkit.getOnlinePlayers()) {
            GameProfile skin = ((CraftPlayer) online).getProfile();
            Property property = skin.getProperties().get("textures").stream().findFirst().orElse(null);
            lines.add(new TabEntry(column, row, player.getDisplayName()).setPing(((CraftPlayer) online).getHandle().ping).setSkin(new Skin(property.getValue(), property.getSignature())));
            if (column++ < 2) {
                continue;
            }
            column = 0;

            if (row++ < 19) {
                continue;
            }
            row = 0;
        }
        return lines;
    }
}
